## hugin 2024.0.1+dfsg

=== CMakeLists.txt ===

# require at least cmake 3.15
cmake_minimum_required(VERSION 3.15 FATAL_ERROR )

# prevent in-tree building
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "In-source builds are not allowed.")
endif()

cmake_policy(SET CMP0003 NEW)
if(POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW)
endif()
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()
if(POLICY CMP0127)
  cmake_policy(SET CMP0127 NEW)
endif()

if(APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9")
  if (MAC_SELF_CONTAINED_BUNDLE)
      set(CMAKE_LIBRARY_PATH ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/lib)
      set(CMAKE_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/include ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin)
  endif(MAC_SELF_CONTAINED_BUNDLE)
  # for FindOpenMP
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/include)
endif(APPLE)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules )

##
## Cleaner Debian Packaging (disable by -DDISABLE_DPKG=ON)
##
OPTION (DISABLE_DPKG "Do not use debian scripts to get package dependences" OFF)


IF(NOT DISABLE_DPKG)
  set(ARCH_TRIPLET)
  if(UNIX)
    FIND_PROGRAM(DPKG_ARCHITECTURE_EXECUTABLE dpkg-architecture)
    if(DPKG_ARCHITECTURE_EXECUTABLE)
      EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
        OUTPUT_VARIABLE ARCH_TRIPLET
        ERROR_VARIABLE ERROR_ARCH_TRIPLET
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
  endif()
  if(ARCH_TRIPLET)
    set(SYSTEM_LIB_DIRS /usr/lib /usr/lib/${ARCH_TRIPLET} /usr/local/lib)
  else()
    set(SYSTEM_LIB_DIRS /usr/lib /usr/local/lib)
  endif()
ENDIF()

include(HuginMacros)
include(CheckIncludeFiles)

##  global setup
project(hugin)

# version
set(V_MAJOR 2024)
set(V_MINOR 0)
set(V_PATCH 1)

#
# Check for mercurial and get current revision
#

IF(EXISTS ${PROJECT_SOURCE_DIR}/.hg)
  FIND_PACKAGE(Hg)
  IF(HG_FOUND)
    EXECUTE_PROCESS(COMMAND ${HG_EXECUTABLE} summary WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}" OUTPUT_VARIABLE _release OUTPUT_STRIP_TRAILING_WHITESPACE)
    foreach(_v_l ${_release})
      if(_v_l MATCHES "^.*: *[^0-9]*\([0-9]+\):\([a-z0-9]+\)")
        set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_1})
        set(HUGIN_WC_REVISION ${CMAKE_MATCH_2})
      endif()
    endforeach()
  ELSE()
    SET(HUGIN_WC_REVISION 0)
  ENDIF()
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_DEVELOPMENT_VERSION 1)
  FILE(WRITE ${PROJECT_SOURCE_DIR}/rev.txt "${HUGIN_WC_REVISION}")
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
ELSE()
  IF (EXISTS ${PROJECT_SOURCE_DIR}/.svn)
    # comment out the following line to compile an old version from the subversion repository
    MESSAGE(FATAL_ERROR "Hugin subversion repository is not up to date. The development happens now in mercurial repository. Please switch to mercurial. Sorry for the inconsistency")
  ENDIF()

  SET(CPACK_PACKAGE_VERSION_PATCH ${V_PATCH})
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_WC_REVISION 0)
  FILE(READ "${PROJECT_SOURCE_DIR}/rev.txt" HUGIN_WC_REVISION)
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
  MESSAGE("-- Assuming this is a tarball (release) build for ${HUGIN_PACKAGE_VERSION}")
  SET(HUGIN_DEVELOPMENT_VERSION 0)
ENDIF()

# version to display
IF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "Pre-Release ${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ELSE (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ENDIF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)

# version for internal libraries.
set(HUGIN_LIB_VERSION 0.0)

# set include path for internal libraries before using finding and initializing
# external dependencies. This makes sure that "our" include paths are specified
# before any system includes

include_directories( ${CMAKE_BINARY_DIR}/src )
include_directories( ${CMAKE_SOURCE_DIR}/src/hugin_base )
include_directories( ${CMAKE_SOURCE_DIR}/src/celeste )
include_directories( ${CMAKE_BINARY_DIR}/src/celeste )
include_directories( ${CMAKE_SOURCE_DIR}/src )

# this function is not available on some systems, notably FreeBSD and Windows
include(CheckFunctionExists)
set(CMAKE_REQUIRED_LIBRARIES -lm)
check_function_exists(log1p HAVE_LOG1P)

#
# find dependencies
#
IF (UNIX)
FIND_PACKAGE(PkgConfig)
ENDIF (UNIX)

set(HUGIN_SHARED "1" CACHE STRING "Build shared internal libraries" )

#
# Setup windows search paths for dependencies
#
IF (WIN32)
  ##
  ## The directory that contains the hugin source root is a good
  ## place to look for support packages, so post it in cache.
  ## 
  ## Our FIND_PACKAGE calls modules will search SOURCE_BASE_DIR
  ## after the local standard places  
  ##
  # extract pathname from CMAKE_SOURCE_DIR (note result must be a local var)
  STRING( REGEX REPLACE "(.*)/[^/]+$" "\\1" work "${CMAKE_SOURCE_DIR}" )
  # create the cache entry
  SET( SOURCE_BASE_DIR ${work} CACHE FILEPATH "parent dir of hugin source root" )

  # wxWidgets
  IF(NOT wxWidgets_ROOT_SUFFIX)
    SET( wxWidgets_ROOT_SUFFIX 3.0.0 CACHE STRING "version of wxWidgets." FORCE )
  ENDIF(NOT wxWidgets_ROOT_SUFFIX)
  IF(NOT wxWidgets_ROOT_DIR)
    SET(wxWidgets_ROOT_DIR ${SOURCE_BASE_DIR}/wxWidgets-${wxWidgets_ROOT_SUFFIX})
  ENDIF()
ENDIF(WIN32)

##
## wxWidgets
##
#  This must come before FINDs for tiff, jpeg, png, zlib to enable
#  finding the wxWidgets distributions of those packages (Win32 only).
IF(WIN32)
  FIND_PACKAGE(wxWidgets REQUIRED base core aui xrc html xml adv gl qa propgrid)
ELSE()
# Unix needs also wxWidgets net library
  FIND_PACKAGE(wxWidgets REQUIRED base core aui xrc html xml adv gl net qa propgrid)
ENDIF()

# hugin requires wxwidgets 3.0 or above
IF (UNIX)
  EXECUTE_PROCESS(
    COMMAND ${wxWidgets_CONFIG_EXECUTABLE} --version
    OUTPUT_VARIABLE wxWidgets_VERSION
  )
  STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+)\\..*" "\\1"  wxWidgets_VERSION ${wxWidgets_VERSION})
  IF(wxWidgets_VERSION VERSION_LESS "3.0")
    MESSAGE(FATAL_ERROR "At least wxWidgets 3.0 is required")
  ENDIF()
  IF(wxWidgets_VERSION VERSION_GREATER "3.1.0")
    SET(USE_XDG_DIRS 1)
  ELSE()
    UNSET(USE_XDG_DIRS)
  ENDIF()
  # Ubuntu has 2 different devel packages, we need the GUI version
  EXECUTE_PROCESS(
    COMMAND ${wxWidgets_CONFIG_EXECUTABLE} --query-toolkit
    OUTPUT_VARIABLE wxWidgets_TOOLKIT
  )
  IF(wxWidgets_TOOLKIT STREQUAL "base")
    MESSAGE(FATAL_ERROR "wxWidgets is as non-GUI package configured. Check you wxWidgets installation (maybe wxgtkXX-devel is missing)")
  ENDIF()
ENDIF (UNIX)

##
## Graphics libraries
##
# wxWidgets sub-packages will be used if native ones aren't found

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
FIND_PACKAGE(JPEG REQUIRED)
INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})

IF(WIN32 AND NOT HUGIN_SHARED)
IF(NOT ${WX_jpeg} MATCHES ${JPEG_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libjpeg and wxjpeg. This does not work with static libs. Use wxjpeg for libjpeg")
ENDIF()
IF(NOT ${WX_zlib} MATCHES ${ZLIB_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libzlib and wxzlib. This does not work with static libs. Use wxzlib for libzlib")
ENDIF()
IF(NOT ${WX_png} MATCHES ${PNG_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libpng and wxpng. This does not work with static libs. Use wxpng for libpng")
ENDIF()
IF(NOT ${WX_tiff} MATCHES ${TIFF_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libtiff and wxtiff. This does not work with static libs. Use wxtiff for libtiff")
ENDIF()

ENDIF()

FIND_PACKAGE(OpenEXR REQUIRED)
include_directories(${OPENEXR_INCLUDE_DIRS})

FIND_PACKAGE(VIGRA 1.9.0 REQUIRED)
include_directories(${VIGRA_INCLUDE_DIR})

FIND_PACKAGE(EXIV2 REQUIRED)
INCLUDE_DIRECTORIES(${EXIV2_INCLUDE_DIR})

## OpenGL and GLEW

FIND_PACKAGE(OpenGL REQUIRED)
INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
SET(OPENGL_GLEW_LIBRARIES ${OPENGL_LIBRARIES})

IF(NOT APPLE AND NOT WIN32)
  OPTION(BUILD_WITH_EGL "Initialize OpenGL context with OpenGL ES (requires libglew with egl support)" OFF)
  IF(BUILD_WITH_EGL)
    IF(NOT OpenGL_EGL_FOUND)
      MESSAGE(FATAL_ERROR "OpenGL ES not found: Install OpenGL ES header or deactivate option BUILD_WITH_EGL")
    ENDIF()
    MESSAGE(STATUS "Use OpenGL ES")
    SET(HAVE_EGL 1)
    INCLUDE_DIRECTORIES(${OPENGL_EGL_INCLUDE_DIRS})
    SET(OPENGL_GLEW_LIBRARIES ${OPENGL_LIBRARIES} ${OPENGL_egl_LIBRARY})
  ELSE()
    UNSET(HAVE_EGL)
  ENDIF()
ENDIF()

IF (APPLE)
  FIND_PACKAGE(GLUT REQUIRED)
  INCLUDE_DIRECTORIES(${GLUT_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${GLUT_LIBRARIES})
ENDIF()
OPTION(BUILD_WITH_EPOXY "Use libepoxy instead of glew library for OpenGL helper functions" OFF)
IF(BUILD_WITH_EPOXY)
  FIND_PACKAGE(EPOXY REQUIRED)
  INCLUDE_DIRECTORIES(${EPOXY_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${EPOXY_LIBRARIES})
  SET(HAVE_EPOXY 1)
ELSE()
  FIND_PACKAGE(GLEW REQUIRED)
  INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${GLEW_LIBRARIES})
  IF(NOT HUGIN_SHARED OR NOT WIN32)
    ADD_DEFINITIONS(-DGLEW_STATIC)
  ENDIF()
  UNSET(HAVE_EPOXY)
ENDIF()

IF(NOT APPLE AND NOT WIN32)
# on Linux we need the X11 header to get the monitor profile
# when compiled without EGL support also the GPU supports needs
# the X11 header, when using EGL support the X11 header are not
# needed for the GPU part, only for the monitor profile
MESSAGE(STATUS "Searching X11 header")
FIND_PACKAGE(X11 REQUIRED)
ENDIF()
##
## Panotools
##

FIND_PACKAGE(PANO13 2.9.19 REQUIRED)

IF(PANO13_FOUND)
  SET(PANO_LIBRARIES ${PANO13_LIBRARIES})
  SET(PANO_INCLUDE_DIR ${PANO13_INCLUDE_DIR})
ELSE(PANO13_FOUND)
  MESSAGE(SEND_ERROR "libpano13 required")
ENDIF(PANO13_FOUND) 
INCLUDE_DIRECTORIES(${PANO_INCLUDE_DIR})

# Check CXX11 compiler
SET(CMAKE_CXX_STANDARD 11)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
# necessary threads lib
SET(THREADS_PREFER_PTHREAD_FLAG ON)
FIND_PACKAGE(Threads REQUIRED)

IF(WIN32)
  # for Windows Vista support
  ADD_DEFINITIONS(-DPSAPI_VERSION=1)
ENDIF(WIN32)

# check if we have C++17 <filesystem> header
INCLUDE(CheckCXXSourceCompiles)
check_cxx_source_compiles(
  "
    #if defined _MSC_VER && _MSC_VER >= 1920
      #define _SILENCE_EXPERIMENTAL_FILESYSTEM_DEPRECATION_WARNING
      #include <experimental/filesystem>
    #else
      #include <filesystem>
    #endif
    #include <string>
    
    #if defined _MSC_VER && _MSC_VER <= 1900
    namespace fs = std::tr2::sys;
    #else
    namespace fs = std::experimental::filesystem;
    #endif

    int main()
    {
      fs::path filepath;
      filepath=fs::absolute(filepath);
      std::string s=filepath.filename().string();
      return 0;    
    };
  "
  HAVE_STD_FILESYSTEM
)

IF(HAVE_STD_FILESYSTEM)
# in this combination we don't need Boost anymore
ELSE()
##
## Boost
##
# I am sick of having to edit the boost rev number in this file.
# Now it is a cache variable you can edit in cmakesetup --TKS
#
IF( NOT Boost_root_suffix )
  SET( Boost_root_suffix _1_54_0 CACHE STRING "suffix of boost root dir." FORCE )
ENDIF( NOT Boost_root_suffix )

IF(WIN32)
  IF(HUGIN_SHARED)
    SET(Boost_USE_STATIC_LIBS OFF)
    SET(Boost_USE_STATIC_RUNTIME OFF)
    # ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
    # ADD_DEFINITIONS(-D_DLL)
    ADD_DEFINITIONS(-DBOOST_ALL_NO_LIB)
  ELSE()
    SET(Boost_USE_STATIC_LIBS ON)
    SET(Boost_USE_STATIC_RUNTIME ON)
  ENDIF()
  # If BOOST_ROOT was defined in the environment, use it. 
  IF(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
    SET(BOOST_ROOT $ENV{BOOST_ROOT})
  ENDIF()
  IF(NOT BOOST_ROOT)
    SET(BOOST_ROOT ${SOURCE_BASE_DIR}/boost${Boost_root_suffix})
  ENDIF()
ENDIF(WIN32)

FIND_PACKAGE(Boost 1.47 COMPONENTS filesystem system)

IF (NOT Boost_FOUND)
  IF(WIN32)

=== src/deghosting/CMakeLists.txt ===

add_executable(deghosting_mask deghosting_mask.cpp deghosting.h deghosting.cpp denoise.h khan.h support.h threshold.h)
target_link_libraries(deghosting_mask ${common_libs} ${image_libs})

install(TARGETS deghosting_mask DESTINATION ${BINDIR})

=== src/hugin1/CMakeLists.txt ===

include_directories( ${CMAKE_SOURCE_DIR}/src/hugin1 )

INCLUDE(${wxWidgets_USE_FILE})

# do we need to define _UNICODE on windows?
IF(WIN32)
  ADD_DEFINITIONS(-D_UNICODE -DUNICODE)
ENDIF(WIN32)

# populate correct dpi aware manifest from wxWidgets
IF(WIN32)
  IF(CMAKE_SIZEOF_VOID_P EQUAL 8) 
    # 64 bit build
    FIND_FILE(WINDOWS_DPI_MANIFEST 
      NAMES amd64_dpi_aware_pmv2.manifest amd64-dpi-aware-pmv2.manifest wx_dpi_aware_pmv2.manifest 
      PATHS "${wxWidgets_ROOT_DIR}/include/wx/msw/"
    )
  ELSE()
    # 32 bit build
    FIND_FILE(WINDOWS_DPI_MANIFEST 
      NAMES wx_dpi_aware_pmv2.manifest wx-dpi-aware-pmv2.manifest
      PATHS "${wxWidgets_ROOT_DIR}/include/wx/msw/"
    )
  ENDIF()
  IF(NOT WINDOWS_DPI_MANIFEST)
    MESSAGE(FATAL_ERROR "Manifest in wx directory not found. Is wxWidgets not new enough or corrupted?")
  ENDIF()
ENDIF()

add_subdirectory(base_wx)
add_subdirectory(stitch_project)
add_subdirectory(icpfind)
add_subdirectory(executor)
add_subdirectory(hugin)
add_subdirectory(ptbatcher)
add_subdirectory(calibrate_lens)

=== src/hugin_script_interface/CMakeLists.txt ===
# This CMakeList.txt is needed to make The Python 
# scripting interface.

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

MESSAGE(STATUS "Python libs version: ${Python3_VERSION}")

# access to the swig runtime code in the hpi module is via
# inclusion of a generated header file, swigpyrun.h:

ADD_CUSTOM_COMMAND(OUTPUT swigpyrun.h
  COMMAND "${SWIG_EXECUTABLE}"
  ARGS "-c++" "-python" "-external-runtime"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMENT "Build header file..."
)

SET_SOURCE_FILES_PROPERTIES("${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h"
  GENERATED)

# this generated header file and a bit of C++ code make up
# the hpi sources. This is the part of hpi/hsi that actually
# gets linked into hugin to provide access to Python and the
# plugin interface, the remaining code (hsi) stands alone as
# a python module and is dynamically loaded.

SET(HUGIN_HPI_SOURCES
  hpi.h
  hpi_classes.h
  hpi.cpp
  hpi_classes.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h"
)

# the hpi sources contitute a library:

IF (${HUGIN_SHARED_LIBS})
  add_library(hugin_python_interface SHARED ${HUGIN_HPI_SOURCES})
  set_target_properties(hugin_python_interface PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS hugin_python_interface RUNTIME DESTINATION ${BINDIR})
  ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
    install(TARGETS hugin_python_interface LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
  ELSE(WIN32)
    install(TARGETS hugin_python_interface LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(hugin_python_interface STATIC  ${HUGIN_HPI_SOURCES})
ENDIF (${HUGIN_SHARED_LIBS})
TARGET_LINK_LIBRARIES(hugin_python_interface huginbase ${Python3_LIBRARIES})

# the next section deals with setting up hsi, the hugin scripting
# interface. This part generates the hsi Python module.

# some hugin headers use a technique for generating accessors
# to image variables which SWIG can't process. These sections
# of code have to be C-preprocessed so that SWIG recognizes the
# declarations they make and wrap them. The preprocessing is
# linited to sections of these headers, as will become clearer
# when you read on.

# first we define a variable for the hugin_base path

SET(HUGIN_BASE_DIR "${PROJECT_SOURCE_DIR}/src/hugin_base")

# to preprocess C/C++ code, we need the
# adequate flags which differ from MSVC to gcc:

IF(MSVC)
  SET(PREPROCESSOR_FLAGS "/EP")
ELSE()
  SET(PREPROCESSOR_FLAGS "-E")
ENDIF()

# we put together the compiler command, the preprocess-only flag
# and the definition of _HSI_IGNORE_SECTION to exclude sections of
# the preprocessed files

SET(HSI_C_PREPROCESS
    ${CMAKE_CXX_COMPILER}
    ${PREPROCESSOR_FLAGS}
    "-D_HSI_IGNORE_SECTION"
)

# this macro sets up the custom command to preprocess ${in}
# into ${out} and allows to specify additional dependencies,
# in this case that will be image_variables.h

MACRO(preprocess in out depends)
ADD_CUSTOM_COMMAND(OUTPUT ${out}
    COMMAND ${HSI_C_PREPROCESS} ${in} > ${out}
    DEPENDS ${in} ${depends}
)
SET_SOURCE_FILES_PROPERTIES(${out} GENERATED)
ENDMACRO(preprocess)

# we C-preprocess the sections from accessor-generating
# headers that SWIG needs to see, ignoring the parts
# where _HSI_IGNORE_SECTION is define. The resulting
# preprocessed code is put into the target tree.

preprocess("${HUGIN_BASE_DIR}/panodata/ImageVariableGroup.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_ImageVariableGroup.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

preprocess("${HUGIN_BASE_DIR}/panodata/Panorama.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_Panorama.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

preprocess("${HUGIN_BASE_DIR}/panodata/PanoramaData.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_PanoramaData.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

preprocess("${HUGIN_BASE_DIR}/panodata/SrcPanoImage.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_SrcPanoImage.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

# we make a variable containing all preprocessed header
# files that are to be wrapped

SET(hsi_preprocessed
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_ImageVariableGroup.h"
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_Panorama.h"
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_PanoramaData.h"
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_SrcPanoImage.h"
)

# and another variable with all unmodified header
# files that are to be wrapped

SET(hsi_wrappees
  "${HUGIN_BASE_DIR}/appbase/DocumentData.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaData.h"
  "${HUGIN_BASE_DIR}/panodata/ImageVariable.h"
  "${HUGIN_BASE_DIR}/panodata/ImageVariableGroup.h"
  "${HUGIN_BASE_DIR}/panodata/StandardImageVariableGroups.h"
  "${HUGIN_BASE_DIR}/panodata/ImageVariableTranslate.h"
  "${HUGIN_BASE_DIR}/panodata/Lens.h"
  "${HUGIN_BASE_DIR}/panodata/SrcPanoImage.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaVariable.h"
  "${HUGIN_BASE_DIR}/panodata/ControlPoint.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaOptions.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaData.h"
  "${HUGIN_BASE_DIR}/panodata/Panorama.h"
  "${HUGIN_BASE_DIR}/panotools/PanoToolsUtils.h"
  "${HUGIN_BASE_DIR}/panotools/PanoToolsInterface.h"
  "${HUGIN_BASE_DIR}/panotools/PanoToolsOptimizerWrapper.h"
  "${HUGIN_BASE_DIR}/algorithms/PanoramaAlgorithm.h"
  "${HUGIN_BASE_DIR}/algorithms/StitcherAlgorithm.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateCPStatistics.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateMeanExposure.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateOptimalROI.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateOptimalScale.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateOverlap.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/RotatePanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/LayerStacks.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/StraightenPanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/TranslatePanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/control_points/CleanCP.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/CalculateFOV.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/CenterHorizontally.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/ComputeImageROI.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/FitPanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/NonaFileStitcher.h"
  "${HUGIN_BASE_DIR}/algorithms/optimizer/PhotometricOptimizer.h"
  "${HUGIN_BASE_DIR}/algorithms/optimizer/PTOptimizer.h"
  "${HUGIN_BASE_DIR}/algorithms/point_sampler/PointSampler.h"
)

# we tell SWIG to also look in the target path

SET(CMAKE_SWIG_FLAGS "-I${CMAKE_CURRENT_BINARY_DIR}")

# now we add the dependencies of the hsi SWIG module
# from all the wrapped files.

SET(SWIG_MODULE_hsi_EXTRA_DEPS
  ${hsi_preprocessed}
  ${hsi_wrappees}
)

# finally, we specify the hsi module itself

SET_SOURCE_FILES_PROPERTIES(hsi.i PROPERTIES CPLUSPLUS ON)
SWIG_ADD_LIBRARY(hsi LANGUAGE python SOURCES hsi.i)
SET_PROPERTY(SOURCE hsi.i PROPERTY COMPILE_OPTIONS -py3)
SWIG_LINK_LIBRARIES(hsi ${Python3_LIBRARIES} ${common_libs})

# The remainder defines where the files are installed.

IF(WIN32)
    INSTALL(TARGETS ${SWIG_MODULE_hsi_REAL_NAME} DESTINATION ${BINDIR})
    INSTALL(FILES hpi.py DESTINATION ${BINDIR})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hsi.py DESTINATION ${BINDIR})
ELSE()
    # Linux/MacOS
    # install Python related files into folder depending on used Python version

    EXECUTE_PROCESS( COMMAND ${Python3_EXECUTABLE} -c "from sysconfig import get_path; print(get_path(\"platlib\"))"
                     OUTPUT_VARIABLE pyinstalldir
                     OUTPUT_STRIP_TRAILING_WHITESPACE)

    MESSAGE("-- Install Python libs into ${pyinstalldir}")

    INSTALL(TARGETS ${SWIG_MODULE_hsi_REAL_NAME}
            LIBRARY DESTINATION ${pyinstalldir}
            NAMELINK_SKIP
            )

    INSTALL(PROGRAMS hpi.py
            DESTINATION ${pyinstalldir}
            )

    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hsi.py
            DESTINATION ${pyinstalldir}
            )

ENDIF()

ADD_SUBDIRECTORY(plugins)
ADD_SUBDIRECTORY(plugins-dev)

=== src/foreign/getopt/CMakeLists.txt ===

add_library(hugingetopt STATIC src/getopt.c include/getopt.h)

=== src/hugin1/calibrate_lens/CMakeLists.txt ===

set(CALLENSGUI_SOURCE LensCalApp.cpp LensCalFrame.cpp LensCalImageCtrl.cpp LensCalTypes.cpp)
set(CALLENSGUI_HEADER LensCalApp.h LensCalFrame.h LensCalImageCtrl.h LensCalTypes.h)

IF (WIN32)
  add_executable(calibrate_lens_gui WIN32 ${CALLENSGUI_SOURCE} ${CALLENSGUI_HEADER} calibrate_lens_gui_rc.rc ${WINDOWS_DPI_MANIFEST})
ELSEIF(APPLE)

  set( PROGNAME calibrate_lens_gui )
  #set( MACOSX_BUNDLE_ICON_FILE ../hugin/Hugin.icns )

  set( INFO_PLIST ${CMAKE_MODULE_PATH}/HuginBundleInfo.plist.in)

  set( MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.hugin.calibrate_lens_gui)
  set( MACOSX_BUNDLE_BUNDLE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH} )
  set( MACOSX_BUNDLE_SHORT_VERSION_STRING ${MACOSX_BUNDLE_BUNDLE_VERSION})
  set( MACOSX_BUNDLE_LONG_VERSION_STRING "Version ${MACOSX_BUNDLE_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_INFO_STRING "calibrate_lens_gui ${MACOSX_BUNDLE_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_BUNDLE_NAME "calibrate_lens_gui" )
  set( MACOSX_BUNDLE_COPYRIGHT "Copyright 2024 Pablo d'Angelo" )
  # set( MACOSX_BUNDLE_SIGNATURE "Hgin" )

  IF(MAC_SELF_CONTAINED_BUNDLE)
    
    #translations
    FILE(GLOB PO_FILES "${CMAKE_SOURCE_DIR}/src/translations/*.po")
    SET(TRANSLATION_FILES )
    FOREACH(_file_po ${PO_FILES})
      GET_FILENAME_COMPONENT(LANG ${_file_po} NAME_WE)
      SET(_file_out ${CMAKE_BINARY_DIR}/src/translations/mac/${LANG}.lproj/hugin.mo)
      LIST(APPEND TRANSLATION_FILES ${_file_out} )
      SET_SOURCE_FILES_PROPERTIES( ${_file_out} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources/${LANG}.lproj" 
              GENERATED TRUE)
    ENDFOREACH(_file_po)

    SET(EN_US_HACK "${CMAKE_BINARY_DIR}/src/translations/mac/en_US.lproj")
    LIST(APPEND TRANSLATION_FILES ${EN_US_HACK})
    SET_SOURCE_FILES_PROPERTIES( ${EN_US_HACK} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources" 
              GENERATED TRUE)


    #xrc files
    FILE(GLOB_RECURSE XRC_FILES ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.html 
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.htm
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.hhc
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.hhk 
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.hhp
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.xrc
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.ico
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.jpg
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.png
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.txt
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.pl )

    FOREACH(_file ${XRC_FILES})
      GET_FILENAME_COMPONENT(_file_dir ${_file} PATH)
      FILE(RELATIVE_PATH _file_dir "${CMAKE_SOURCE_DIR}/src/hugin1/hugin/" ${_file_dir})
      IF(${_file_dir} MATCHES "xrc/data/help_*")
        CONTINUE()
      ENDIF()
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources/${_file_dir}")
    ENDFOREACH(_file)
    

    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE ${CALLENSGUI_SOURCE} ${CALLENSGUI_HEADER}
          ${TRANSLATION_FILES} ${XRC_FILES} )
    if(INFO_PLIST)
      set_target_properties(${PROGNAME} PROPERTIES
            MACOSX_BUNDLE_INFO_PLIST ${INFO_PLIST})
    endif(INFO_PLIST)

    ADD_DEPENDENCIES(${PROGNAME} translations)

  ELSE(MAC_SELF_CONTAINED_BUNDLE)

    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE ${CALLENSGUI_SOURCE} ${CALLENSGUI_HEADER})

  ENDIF(MAC_SELF_CONTAINED_BUNDLE)

ELSE (WIN32)
 add_executable(calibrate_lens_gui ${CALLENSGUI_SOURCE} ${CALLENSGUI_HEADER})
ENDIF (WIN32)


target_link_libraries(calibrate_lens_gui huginbasewx ${common_libs} ${image_libs} ${wxWidgets_LIBRARIES})

IF (APPLE)
  IF (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS calibrate_lens_gui
            DESTINATION ${INSTALL_OSX_BUNDLE_DIR})
  ELSE (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION "Hugin"
            COMPONENT ${PROGNAME})
  ENDIF (NOT MAC_SELF_CONTAINED_BUNDLE)
ELSE(APPLE)
    INSTALL(TARGETS calibrate_lens_gui DESTINATION ${BINDIR})
    IF(UNIX)
        # install further stuff (icons etc.)
        INSTALL(FILES calibrate_lens_gui.desktop DESTINATION ${DATADIR}/applications)
    ENDIF(UNIX)
ENDIF(APPLE)

set_property(INSTALL "bin/$<TARGET_FILE_NAME:calibrate_lens_gui>"
  PROPERTY CPACK_START_MENU_SHORTCUTS "Lens calibration GUI"
)

=== src/hugin1/ptbatcher/CMakeLists.txt ===
set(PTBATCHERGUI_SOURCE 
      PTBatcherGUI.cpp Batch.cpp RunStitchFrame.cpp ProjectArray.cpp ProjectListBox.cpp 
      BatchFrame.cpp FindPanoDialog.cpp FailedProjectsDialog.cpp BatchTrayIcon.cpp ProgressStatusBar.cpp
      ChangeUserDefinedDialog.cpp GenerateSequenceDialog.cpp)
set( PTBATCHERGUI_HEADER PTBatcherGUI.h Batch.h RunStitchFrame.h ProjectArray.h ProjectListBox.h
                         BatchFrame.h DirTraverser.h FindPanoDialog.h FailedProjectsDialog.h 
                         BatchTrayIcon.h ProgressStatusBar.h PTBatcherGUI_rc.rc ChangeUserDefinedDialog.h
                         GenerateSequenceDialog.h )
IF (WIN32)
  add_executable(PTBatcherGUI WIN32 ${PTBATCHERGUI_SOURCE} ${PTBATCHERGUI_HEADER} ${WINDOWS_DPI_MANIFEST})
  IF (MINGW)
    # MinGW doesn't support #pragma comment(lib, "PowrProf.lib")
    target_link_libraries(PTBatcherGUI -lpowrprof)
  ENDIF(MINGW)
ELSEIF(APPLE)
  set( PROGNAME PTBatcherGUI )
  set( MACOSX_BUNDLE_ICON_FILE ../hugin/PTBatcherGui.icns )

  set( INFO_PLIST ${CMAKE_MODULE_PATH}/HuginBundleInfoPTO.plist.in)
  set( MACOSX_BUNDLE_TYPE_ROLE Viewer )
  
  set( MACOSX_BUNDLE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH} )
  set( MACOSX_BUNDLE_SHORT_VERSION_STRING ${MACOSX_BUNDLE_VERSION})
  set( MACOSX_BUNDLE_LONG_VERSION_STRING "Version ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.hugin.PTBatcherGUI)
  set( MACOSX_BUNDLE_INFO_STRING "PTBatcherGUI ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_BUNDLE_NAME "PTBatcherGUI" )
  set( MACOSX_BUNDLE_COPYRIGHT "Copyright 2024 Pablo d'Angelo" )

  IF(MAC_SELF_CONTAINED_BUNDLE)

    # Tools
    set( TOOLS ${CMAKE_BINARY_DIR}/src/tools/align_image_stack ${CMAKE_BINARY_DIR}/src/tools/nona
               ${CMAKE_BINARY_DIR}/src/tools/hugin_hdrmerge ${CMAKE_BINARY_DIR}/src/tools/verdandi
               ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin/enblend
               ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin/enfuse 
    )

    FOREACH(_file ${TOOLS})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "MacOS" 
           GENERATED TRUE)
    ENDFOREACH(_file)

    #other files
    FILE(GLOB OTHER ${CMAKE_SOURCE_DIR}/src/hugin1/executor/*.executor)
    LIST(APPEND OTHER 
                      ${CMAKE_SOURCE_DIR}/src/celeste/data/celeste.model
                      ${CMAKE_SOURCE_DIR}/src/hugin1/base_wx/hugin_exiftool_copy.arg)
    FOREACH(_file ${OTHER})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "Resources/xrc" )
    ENDFOREACH(_file)

    #translations
    FILE(GLOB PO_FILES "${CMAKE_SOURCE_DIR}/src/translations/*.po")
    SET(TRANSLATION_FILES )
    FOREACH(_file_po ${PO_FILES})
      GET_FILENAME_COMPONENT(LANG ${_file_po} NAME_WE)
      SET(_file_out ${CMAKE_BINARY_DIR}/src/translations/mac/${LANG}.lproj/hugin.mo)
      LIST(APPEND TRANSLATION_FILES ${_file_out} )
      SET_SOURCE_FILES_PROPERTIES( ${_file_out} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources/${LANG}.lproj" 
              GENERATED TRUE)
    ENDFOREACH(_file_po)

    SET(EN_US_HACK "${CMAKE_BINARY_DIR}/src/translations/mac/en_US.lproj")
    LIST(APPEND TRANSLATION_FILES ${EN_US_HACK})
    SET_SOURCE_FILES_PROPERTIES( ${EN_US_HACK} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources" 
              GENERATED TRUE)


    #xrc files
    FILE(GLOB_RECURSE XRC_FILES ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.html 
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.htm
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.hhc
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.hhk 
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.hhp
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.xrc
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.ico
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.jpg
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.png
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.txt
                                ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/*.pl )

    FOREACH(_file ${XRC_FILES})
      GET_FILENAME_COMPONENT(_file_dir ${_file} PATH)
      FILE(RELATIVE_PATH _file_dir "${CMAKE_SOURCE_DIR}/src/hugin1/hugin/" ${_file_dir})
      IF(${_file_dir} MATCHES "xrc/data/help_*")
        CONTINUE()
      ENDIF()
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources/${_file_dir}")
    ENDFOREACH(_file)

    # Icons
    set( ICON_FILES "../hugin/${MACOSX_BUNDLE_ICON_FILE}" "../hugin/${MACOSX_BUNDLE_TYPE_ICON_FILE}" )
    FOREACH(_file ${ICON_FILES})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "Resources" )
    ENDFOREACH(_file)

    #help files
    FILE(GLOB HELP_FILES ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.css
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.htm
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.html
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.ico
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.gif
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.JPG
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.jpg
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.png
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.xpm
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.hhc
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.hhk
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/*.hhp
                         ${CMAKE_SOURCE_DIR}/src/hugin1/hugin/xrc/data/help_en_EN/.manual )
    FOREACH(_file ${HELP_FILES})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES
           MACOSX_PACKAGE_LOCATION "Resources/en_US.lproj/help" )
    ENDFOREACH(_file)


    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE ${PTBATCHERGUI_SOURCE} ${PTBATCHERGUI_HEADER}
          ${ICON_FILES} ${TRANSLATION_FILES} ${XRC_FILES} ${TOOLS} ${OTHER})
    if(INFO_PLIST)
      set_target_properties(${PROGNAME} PROPERTIES
            MACOSX_BUNDLE_INFO_PLIST ${INFO_PLIST})
    endif(INFO_PLIST)

    ADD_DEPENDENCIES(${PROGNAME} align_image_stack nona hugin_hdrmerge verdandi
      translations)


  else (MAC_SELF_CONTAINED_BUNDLE)

    set( ICON_FILES ${MACOSX_BUNDLE_ICON_FILE} ${MACOSX_BUNDLE_TYPE_ICON_FILE} )
    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE ${PTBATCHERGUI_SOURCE} ${PTBATCHERGUI_HEADER} ${ICON_FILES} ${OTHER})

  ENDIF(MAC_SELF_CONTAINED_BUNDLE)
     

ELSE (WIN32)
 add_executable(PTBatcherGUI PTBatcherGUI.cpp ${PTBATCHERGUI_SOURCE} ${PTBATCHERGUI_HEADER})
ENDIF (WIN32)


target_link_libraries(PTBatcherGUI huginbasewx ${common_libs} ${image_libs} ${wxWidgets_LIBRARIES})

IF (APPLE)
  IF (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS PTBatcherGUI
            DESTINATION ${INSTALL_OSX_BUNDLE_DIR})
  ELSE (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION "Hugin"
            COMPONENT ${PROGNAME})
  ENDIF (NOT MAC_SELF_CONTAINED_BUNDLE)
ELSE(APPLE)
  install(TARGETS PTBatcherGUI
          DESTINATION ${BINDIR})
  IF (UNIX)
    INSTALL(FILES PTBatcherGUI.desktop DESTINATION ${DATADIR}/applications)
  ENDIF (UNIX)
ENDIF(APPLE)

set_property(INSTALL "bin/$<TARGET_FILE_NAME:PTBatcherGUI>"
  PROPERTY CPACK_START_MENU_SHORTCUTS "PTBatcherGUI - Batch processor"
)

=== src/hugin1/stitch_project/CMakeLists.txt ===

set( PROGNAME hugin_stitch_project )
IF (WIN32)
  add_executable(${PROGNAME} WIN32 hugin_stitch_project.cpp hugin_stitch_project_rc.rc ${WINDOWS_DPI_MANIFEST})
ELSEIF(APPLE)
  set( PROGNAME HuginStitchProject )
  set( MACOSX_BUNDLE_ICON_FILE ../hugin/Hugin.icns )

  set( INFO_PLIST ${CMAKE_MODULE_PATH}/HuginBundleInfo.plist.in)
  # disabled because stitch_project can't handle MacOpenFiles correctly
  # set( INFO_PLIST ${CMAKE_MODULE_PATH}/HuginBundleInfoPTO.plist.in)
  # set( MACOSX_BUNDLE_TYPE_ROLE Viewer )
  
  set( MACOSX_BUNDLE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH} )
  set( MACOSX_BUNDLE_SHORT_VERSION_STRING ${MACOSX_BUNDLE_VERSION})
  set( MACOSX_BUNDLE_LONG_VERSION_STRING "Version ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.HuginStitchProject)
  set( MACOSX_BUNDLE_INFO_STRING "HuginStitchProject ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_BUNDLE_NAME "HuginStitchProject" )
  set( MACOSX_BUNDLE_COPYRIGHT "Copyright 2024 Pablo d'Angelo" )

  IF(MAC_SELF_CONTAINED_BUNDLE)

    # Tools
    set( TOOLS ${CMAKE_BINARY_DIR}/src/tools/align_image_stack ${CMAKE_BINARY_DIR}/src/tools/nona
               ${CMAKE_BINARY_DIR}/src/tools/hugin_hdrmerge ${CMAKE_BINARY_DIR}/src/tools/verdandi
               ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin/enblend
               ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin/enfuse 
    )

    FOREACH(_file ${TOOLS})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "MacOS" 
           GENERATED TRUE)
    ENDFOREACH(_file)


    #other files
    FILE(GLOB OTHER ${CMAKE_SOURCE_DIR}/src/hugin1/executor/*.executor)
    LIST(APPEND OTHER ${CMAKE_SOURCE_DIR}/src/hugin1/base_wx/hugin_exiftool_copy.arg)
    FOREACH(_file ${OTHER})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "Resources/xrc" )
    ENDFOREACH(_file)

    #translations
    FILE(GLOB PO_FILES "${CMAKE_SOURCE_DIR}/src/translations/*.po")
    SET(TRANSLATION_FILES )
    FOREACH(_file_po ${PO_FILES})
      GET_FILENAME_COMPONENT(LANG ${_file_po} NAME_WE)
      SET(_file_out ${CMAKE_BINARY_DIR}/src/translations/mac/${LANG}.lproj/hugin.mo)
      LIST(APPEND TRANSLATION_FILES ${_file_out} )
      SET_SOURCE_FILES_PROPERTIES( ${_file_out} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources/${LANG}.lproj" 
              GENERATED TRUE)
    ENDFOREACH(_file_po)

    SET(EN_US_HACK "${CMAKE_BINARY_DIR}/src/translations/mac/en_US.lproj")
    LIST(APPEND TRANSLATION_FILES ${EN_US_HACK})
    SET_SOURCE_FILES_PROPERTIES( ${EN_US_HACK} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources" 
              GENERATED TRUE)

    # Icons
    set( ICON_FILES "../hugin/${MACOSX_BUNDLE_ICON_FILE}" "../hugin/${MACOSX_BUNDLE_TYPE_ICON_FILE}" )
    FOREACH(_file ${ICON_FILES})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION 
           "Resources" )
    ENDFOREACH(_file)


    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE hugin_stitch_project.cpp 
          ${ICON_FILES} ${TRANSLATION_FILES} ${TOOLS} ${OTHER})
    if(INFO_PLIST)
      set_target_properties(${PROGNAME} PROPERTIES
            MACOSX_BUNDLE_INFO_PLIST ${INFO_PLIST})
    endif(INFO_PLIST)

    ADD_DEPENDENCIES(${PROGNAME} align_image_stack nona hugin_hdrmerge verdandi
      translations)

  ELSE (MAC_SELF_CONTAINED_BUNDLE)

    set( ICON_FILES ${MACOSX_BUNDLE_ICON_FILE} ${MACOSX_BUNDLE_TYPE_ICON_FILE} )
    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE hugin_stitch_project.cpp 
                    ${ICON_FILES})

  ENDIF(MAC_SELF_CONTAINED_BUNDLE)
     

ELSE (WIN32)
 add_executable(${PROGNAME} hugin_stitch_project.cpp)
ENDIF (WIN32)


target_link_libraries(${PROGNAME} huginbasewx ${common_libs} ${image_libs} ${wxWidgets_LIBRARIES})

IF (APPLE)
  IF (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION ${INSTALL_OSX_BUNDLE_DIR})
  ELSE (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION "Hugin"
            COMPONENT ${PROGNAME})
  ENDIF (NOT MAC_SELF_CONTAINED_BUNDLE)
ELSE(APPLE)
  install(TARGETS ${PROGNAME}
          DESTINATION ${BINDIR})
ENDIF(APPLE)

=== src/hugin1/hugin/xrc/data/help_en_EN/CMakeLists.txt ===

# install help/manual
IF(WIN32)

# running hhc with relative path does not work correctly, so we copy all manual file into temporary
# directory and run hhc there

FILE(GLOB HELPFILES 
  *.htm *.html *.ico *.gif *.JPG *.jpg *.png *.xpm hugin_help_en_EN.hhp help_index_en.hhk help_toc_en.hhc hhc.cmake *.css
)

SET(HELP_DIR ${CMAKE_BINARY_DIR}/help)
SET(HELPFILES2)  # empty list

IF(EXISTS "${ENBLEND_DIR}/doc/enblend.html")
  # when enblend has new documentation, we integate this new doc instead of files from wiki
  LIST(REMOVE_ITEM HELPFILES "${CMAKE_CURRENT_SOURCE_DIR}/Enblend.html")
  LIST(REMOVE_ITEM HELPFILES "${CMAKE_CURRENT_SOURCE_DIR}/Enfuse.html")
  LIST(APPEND HELPFILES "${ENBLEND_DIR}/doc/enblend.html")
  LIST(APPEND HELPFILES "${ENBLEND_DIR}/doc/enfuse.html")
  FILE(GLOB ENBLEND_DOC_IMAGES ${ENBLEND_DIR}/doc/*.png)
  LIST(APPEND HELPFILES ${ENBLEND_DOC_IMAGES})
ENDIF()

FOREACH(_file ${HELPFILES})
  get_filename_component(_filename ${_file} NAME)
  ADD_CUSTOM_COMMAND(
    OUTPUT "${HELP_DIR}/${_filename}"
    COMMAND ${CMAKE_COMMAND} -E copy "${_file}" "${HELP_DIR}/${_filename}"
    DEPENDS ${_file}
    COMMENT "Copy ${_filename} to ${HELP_DIR}"
  )
  SET_SOURCE_FILES_PROPERTIES("${HELP_DIR}/${_filename}" GENERATED)
  LIST(APPEND HELPFILES2 "${HELP_DIR}/${_filename}")
ENDFOREACH()

ADD_CUSTOM_COMMAND(
  OUTPUT ${HELP_DIR}/hugin_help_en_EN.chm
  COMMAND ${CMAKE_COMMAND} -DHTML_HELP_COMPILER=${HTML_HELP_COMPILER} -P hhc.cmake
  # COMMAND ${HTML_HELP_COMPILER} hugin_help_en_EN.hhp
  DEPENDS ${HELPFILES2}
  WORKING_DIRECTORY ${HELP_DIR}
  COMMENT "Building help file"
)
SET_SOURCE_FILES_PROPERTIES("${HELP_DIR}/hugin_help_en_EN.chm" GENERATED)
ADD_CUSTOM_TARGET(chmhelp ALL DEPENDS ${HELPFILE2} ${HELP_DIR}/hugin_help_en_EN.chm )

INSTALL(FILES ${CMAKE_BINARY_DIR}/help/hugin_help_en_EN.chm DESTINATION ${HUGINDATADIR}/xrc/data/)

ELSE(WIN32)

FILE(GLOB DATAFILES *.css *.htm *.html *.ico *.gif *.JPG *.jpg *.png *.xpm *.hhc *.hhk *.hhp
*.manual)

INSTALL(FILES ${DATAFILES} DESTINATION ${HUGINDATADIR}/xrc/data/help_en_EN)

ENDIF(WIN32)

=== debian/changelog ===
hugin (2024.0.1+dfsg-1build3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:05:59 +0200

hugin (2024.0.1+dfsg-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:55:35 +0200

=== debian/control ===
Source: hugin
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
# hugin can use Boost::Signal or in Boost >= 1.54 Boost::Signal2 which is
# shipped in libboost-dev.
Build-Depends:
 cmake (>= 3.15),
 debhelper-compat (= 13),
 dh-python,
 libboost-filesystem-dev (>= 1.47),
 libboost-system-dev (>= 1.47),
 libepoxy-dev,
 libexiv2-dev (>= 0.12),
 libfftw3-dev,
 libflann-dev,
 libjpeg-dev,
 liblcms2-dev,
 libopenexr-dev,
 libpano13-dev (>= 2.9.19~beta1),
 libpng-dev,
 libsqlite3-dev,
 libtiff-dev,
 libvigraimpex-dev (>=1.9),
 libwxgtk3.2-dev,
 libx11-dev,
 pkgconf,
 python3-dev,
 python3-setuptools,
 swig (>= 2.0.4),
 zlib1g-dev,
Build-Conflicts:
 wx2.6-headers,
 wx2.8-headers,
 wx3.0-headers,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: http://hugin.sourceforge.net/
Vcs-Git: https://salsa.debian.org/debian-phototools-team/hugin.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/hugin

Package: hugin
Architecture: any
Depends:
 enblend (>= 3.2),
 enfuse,
 hugin-tools (= ${binary:Version}),
 libimage-exiftool-perl,
 make,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 hugin-bin (<< 0.7.0~svn),
Replaces:
 hugin-bin (<< 0.7.0~svn),
 hugin-data (<< 0.7.0~svn),
 hugin-tools (<< 0.7.0~svn),
Suggests:
 dcraw | rawtherapee | darktable,
Description: panorama photo stitcher - GUI tools
 Hugin is a panorama photo stitching program. Essentially, Hugin is a
 GUI frontend for Panorama Tools. Stitching is accomplished by using
 several overlapping photos taken from the same location, and using
 control points to align and transform the photos so that they can be
 blended together to form a larger image. Hugin allows for the easy
 creation of control points between two images, optimization of the
 image transforms, and much more.
 .
 This package includes the following graphical interfaces, using the
 command-line tools provided in the hugin-tools package:
  * hugin                - Hugin panorama creator.
  * hugin_stitch_project - Hugin batch stitcher.
  * PTBatcherGUI         - Batch controller for the stitching process.
  * calibrate_lens_gui   - Lens calibration tool.

Package: hugin-tools
Architecture: any
Depends:
 hugin-data (= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Breaks:
 hugin-bin (<< 0.7.0~svn),
 ${python3:Breaks},
Replaces:
 hugin-bin (<< 0.7.0~svn),
Recommends:
 libpano13-bin,
Provides:
 python-hsi,
Description: panorama photo stitcher - commandline tools
 Hugin is a panorama photo stitching program.
 .
 This package includes command-line tools used by hugin and other
 packages for image stitching and High Dynamic Range (HDR) images:
  * align_image_stack  - Align overlapping images for HDR creation.
  * autooptimiser      - Optimize image positions.
  * celeste_standalone - Remove cloud-like control points.
  * cpclean            - Remove wrong control points.
  * cpfind             - Patent-free control-point detector
  * deghosting_mask    - Creates mask for removing ghosting in images.
  * fulla              - Correct lens distortion, vignetting, and
                         chromatic aberration.
  * geocpset           - Set geometric control points.
  * hugin_executor     - CLI stitching tool.
  * hugin_hdrmerge     - Merge overlapping images.
  * hugin_lensdb       - Hugin lens database maintenance.
  * icpfind            - Control-point detector wrapper program.
  * linefind           - Detect vertical features in images.
  * nona               - Remap images. (Also does simple stitching.)
  * pano_modify        - Change output parameters of project file.
  * pto_gen            - Generate a Hugin project file from a list of images.
  * pto_lensstack      - Modify assigned lenses and stack in pto files.
  * pto_mask           - Apply a mask.
  * pto_merge          - Merges two or more Hugin project files.
  * pto_move           - Move a project file with all images in it.
  * pto_template       - Apply a template file.
  * pto_var            - Change image variables inside Hugin .pto project
                         files
  * tca_correct        - Calculate transverse chromatic aberration.
  * verdandi           - Blend images using watershed algorithm.
  * vig_optimize       - Determine the radial vignetting.

Package: hugin-data
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Breaks:
 ${python3:Breaks},
# imports of included plugins
Suggests:
 python-wxgtk4.0,
Description: panorama photo stitcher - common data files
 Hugin is a panorama photo stitching program.
 .
 This package includes the data files needed by the hugin and
 hugin-tools packages.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,-z,defs
export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
# Default python version.
PYTHONDEFVERSION := $(shell py3versions -d | sed -e 's/python\([0-9.]\+\)/\1/')

include /usr/share/dpkg/pkg-info.mk

# Upstream version can be overriden so as to fetch newer revisions
# without having to modify the top-most changelog entry
UVERSION ?= $(subst +dfsg,,$(DEB_VERSION_UPSTREAM))

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_auto_install:
	dh_auto_install --verbose
	rm -vf debian/tmp/usr/share/hugin/xrc/data/help_en_EN/LICENCE.manual

	find debian/tmp/usr/share/hugin/data/plugins \
		debian/tmp/usr/share/hugin/data/plugins-templates \
		-name '*.py' -exec \
		sed -i -e 's:^#! */usr/bin/env python$$:#! /usr/bin/python3:' \
		{} +
	rm -v debian/tmp/usr/share/hugin/xrc/data/COPYING.txt

override_dh_auto_configure:
	dh_auto_configure --verbose --\
		-DUSE_GDKBACKEND_X11=on \
		-DBUILD_WITH_EPOXY=on \
		-DBUILD_HSI:BOOL=ON \
		-DPython_ADDITIONAL_VERSIONS=$(PYTHONDEFVERSION)

override_dh_python3:
	dh_python3 -i /usr/share/hugin/data/plugins
	dh_python3 -a

%:
	dh $@ --with python3
